#!/usr/bin/perl -w -I/usr/sausalito/perl -I.

# Author: Kevin K.M. Chiu
# Copyright 2000, Cobalt Networks.  All rights reserved.
# $Id: 50_addAdmin.pl,v 1.12 2000/12/12 23:59:37 kevin Exp $

use strict;
use CCE;
use I18n;

my $cce = new CCE;
$cce->connectuds();

my $i18n = new I18n;

my $uiRight = "systemAdministrator";

# check if admin exists already
my (@oids) = $cce->find("User", {name => "admin"});
if($#oids >= 0) {
  # make sure admin has "systemAdministrator" in uiRights
  # this is to provide backward compatibility to older systems that depends on
  # systemAdministrator flag instead of uiRights to determine UI access rights
  my ($ok, $obj) = $cce->get($oids[0]);
  my @uiRights = $cce->scalar_to_array($obj->{uiRights});
  # add right if it did not exist
  if(! grep /^$uiRight$/, @uiRights) {
    push @uiRights, $uiRight;
  }
  my $uiRightsString = $cce->array_to_scalar(@uiRights);
  $cce->set($oids[0], "", {uiRights => $uiRightsString});

  $cce->bye();
  exit 1;
}

$i18n->setLocale(I18n::i18n_getSystemLocale($cce));

# add
my ($success) = $cce->create("User", {
    fullName => $i18n->get("administrator",{},"base-user"),
    localePreference => "browser",
    name => "admin",
    password => "admin",
    stylePreference => "trueBlue",
    systemAdministrator => "true",
    uiRights => "&$uiRight&"
});

# reserve the admin email alias
#if ($success) {
#	$success = $cce->create("EmailAlias", { 'name' => 'admin', 
#						action => '*RESERVED*' });
#}

$cce->bye();

# failed?
if(!$success) {
  exit 1;
}

# make sure the shell is /bin/bash
`/usr/sbin/usermod -s /bin/bash admin`;
exit 0;
